# https://www.keycloak.org/server/all-config
type Keycloak::Configs = Struct[
  {
    Optional['cache'] => Enum['local', 'ispn'],
    Optional['cache-config-file'] => String[1],
    Optional['cache-stack'] => Enum['tcp','udp','kubernetes','ec2','azure','google'],
    Optional['db'] => Enum['dev-file','dev-mem','mariadb','mysql','oracle','postgres'],
    Optional['db-password'] => String[1],
    Optional['db-pool-initial-size'] => Integer,
    Optional['db-pool-max-size'] => Integer,
    Optional['db-pool-min-size'] => Integer,
    Optional['db-schema'] => String[1],
    Optional['db-url'] => String[1],
    Optional['db-url-database'] => String[1],
    Optional['db-url-host'] => Stdlib::Host,
    Optional['db-url-port'] => Stdlib::Port,
    Optional['db-url-properties'] => String[1],
    Optional['db-username'] => String[1],
    Optional['transaction-xa-enabled'] => Boolean,
    Optional['features'] => Array[String[1]],
    Optional['features-disabled'] => Array[String[1]],
    Optional['hostname'] => Stdlib::Host,
    Optional['hostname-admin'] => Stdlib::Host,
    Optional['hostname-admin-url'] => String[1],
    Optional['hostname-path'] => String[1],
    Optional['hostname-port'] => Stdlib::Port,
    Optional['hostname-strict'] => Boolean,
    Optional['hostname-strict-backchannel'] => Boolean,
    Optional['hostname-strict-https'] => Boolean,
    Optional['hostname-url'] => String[1],
    Optional['http-enabled'] => Boolean,
    Optional['http-host'] => Stdlib::Host,
    Optional['http-port'] => Stdlib::Port,
    Optional['http-relative-path'] => String[1],
    Optional['https-certificate-file'] => Stdlib::Absolutepath,
    Optional['https-certificate-key-file'] => Stdlib::Absolutepath,
    Optional['https-cipher-suites'] => Array[String[1]],
    Optional['https-client-auth'] => Enum['none','request','required'],
    Optional['https-key-store-file'] => Stdlib::Absolutepath,
    Optional['https-key-store-password'] => String[1],
    Optional['https-key-store-type'] => String[1],
    Optional['https-port'] => Stdlib::Port,
    Optional['https-protocols'] => Array[String[1]],
    Optional['https-trust-store-file'] => Stdlib::Absolutepath,
    Optional['https-trust-store-password'] => String[1],
    Optional['https-trust-store-type'] => String[1],
    Optional['health-enabled'] => Boolean,
    Optional['metrics-enabled'] => Boolean,
    Optional['proxy'] => Enum['edge','reencrypt','passthrough','none'],
    Optional['vault'] => Enum['file','hashicorp'],
    Optional['vault-dir'] => Stdlib::Absolutepath,
    Optional['log'] => Array[Enum['console','file','gelf']],
    Optional['log-console-color'] => Boolean,
    Optional['log-console-format'] => String[1],
    Optional['log-console-output'] => Enum['default','json'],
    Optional['log-file'] => Stdlib::Absolutepath,
    Optional['log-file-format'] => String[1],
    Optional['log-file-output'] => Enum['default','json'],
    Optional['log-level'] => String[1],
    Optional['log-gelf-facility'] => String[1],
    Optional['log-gelf-host'] => Stdlib::Host,
    Optional['log-gelf-include-location'] => Boolean,
    Optional['log-gelf-include-message-parameters'] => Boolean,
    Optional['log-gelf-include-stack-trace'] => Boolean,
    Optional['log-gelf-level'] => String[1],
    Optional['log-gelf-max-message-size'] => Integer,
    Optional['log-gelf-port'] => Stdlib::Port,
    Optional['log-gelf-timestamp-format'] => String[1],
    Optional['log-level'] => String[1],
  }
]
